/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
#include "CompoundString.hh"
#include "IMTriggerKeyList.hh"
#ifndef Bool
#define Bool int
#define True 1
#define False 0
#endif

// Hard Coded
#define XK_space               0x020
/**
 * Define all Key Masks
 */
#define IM_ShiftMask               (1<<0)
#define IM_LockMask                (1<<1)
#define IM_ControlMask             (1<<2)
#define IM_Mod1Mask                (1<<3)
#define IM_Mod2Mask                (1<<4)
#define IM_Mod3Mask                (1<<5)
#define IM_Mod4Mask                (1<<6)
#define IM_Mod5Mask                (1<<7)

static
unsigned int
to_modifier(const char *str) {
  CompoundString modifier(str);
  if (modifier == CompoundString("Ctrl")) return IM_ControlMask;
  if (modifier == CompoundString("Shift")) return IM_ShiftMask;
  if (modifier == CompoundString("Meta")) return IM_Mod4Mask;
  if (modifier == CompoundString("Alt")) return IM_Mod1Mask;
  return 0;
}

void
IMTriggerKeyList::add(const char *str) {
    if (!str) return;

  CompoundString buf;
  Bool is_modmask;
  unsigned int mod, mod_mask, tmp_mask;
  unsigned int keysym, modifier, modifier_mask;

  CompoundString names(str);

  buf = names;
  is_modmask = False;
  mod = mod_mask = 0;

  char *bufp = buf;
  CompoundString temp;
  unsigned int pos, pos2;

  // skip leading whitespaces
  while (*bufp == ' ' || *bufp == '\t') bufp++;

  while (*bufp) {
    switch(*bufp) {
    case '~':
      if (is_modmask)
        goto done;
      is_modmask = True;
      bufp += 1;
      while (*bufp == ' ' || *bufp == '\t') bufp++;
      break;
    case '<':
      bufp++;
      while (*bufp == ' ' || *bufp == '\t') bufp++;
      temp = bufp;
      pos = temp.search(">");
      if (pos == -1 || pos == 0) goto done;
      pos2 = temp.search(" ");
      if (pos2 < pos)
        *(bufp + pos2) = 0;
      else
        *(bufp + pos) = 0;
      if ((tmp_mask = to_modifier(bufp)) == 0)
        goto done;
      if (is_modmask) {
        mod_mask |= tmp_mask;
        is_modmask = False;
      } else {
        mod |= tmp_mask;
      }
      bufp += 1 + pos;
      while (*bufp == ' ' || *bufp == '\t') bufp++;
      if (!*bufp)
        goto done;
      break;
    default:
      if (is_modmask) goto done;
      while (*bufp == ' ' || *bufp == '\t') bufp++;
      temp = bufp;
      pos = temp.search(" ");
      if (pos != -1) *(bufp + pos) = 0;
      // keysym = XStringToKeysym(bufp);     FIX ME
      keysym = XK_space;
      modifier = mod;
      modifier_mask = mod_mask;
      /* FIX ME */
      modifier_mask = modifier;

      add(keysym, modifier, modifier_mask);
      mod = 0;
      if (pos != -1) {
        bufp += 1 + pos;
        break;
      } else {
        goto done;
      }
    }
  }
 done:
  return;
}


